LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity decoder is
port(inputs : in std_logic_vector(6 downto 0);
	 RPM	: out std_logic_vector(13 downto 0);
     gear : out std_logic_vector(2 downto 0));
end decoder;

architecture behavior of decoder is

begin
   process(inputs)
   begin
	case inputs(6 downto 3) is	--RPM
	   when "0000" => 
		RPM(13 downto 0) <= "00000000000000";	--0 RPM
	   when "0001" =>
		RPM(13 downto 0) <= "00000000000001";	--1000
	   when "0010" => 
		RPM(13 downto 0) <= "00000000000011";	--2000
	   when "0011" => 
		RPM(13 downto 0) <= "00000000000111";	--3000
	   when "0100" => 
		RPM(13 downto 0) <= "00000000001111";	--4000
   	   when "0101" => 
		RPM(13 downto 0) <= "00000000011111";	--5000
	   when "0110" => 
		RPM(13 downto 0) <= "00000000111111";	--6000
  	   when "0111" => 
		RPM(13 downto 0) <= "00000001111111";	--7000
	   when "1000" => 
		RPM(13 downto 0) <= "00000011111111";	--8000
 	   when "1001" => 
		RPM(13 downto 0) <= "00000111111111";	--9000
	   when "1010" => 
		RPM(13 downto 0) <= "00001111111111";	--10,000
	   when "1011" => 
		RPM(13 downto 0) <= "00011111111111";	--11,000
	   when "1100" => 
		RPM(13 downto 0) <= "00111111111111";	--12,000
	   when "1101" => 
		RPM(13 downto 0) <= "01111111111111";	--13,000
	   when "1110" => 
		RPM(13 downto 0) <= "11111111111111";	--14,000
	   when others =>
		RPM(13 downto 0) <= "11111111111111";	--error
	end case;
	
	case inputs(2 downto 0) is	--Gear Display
	   when "000" =>		--gfedcba
	   	gear(2 downto 0) <=  "1000000";	--0, neutral
	   when "001" =>		--gfedcba
	   	gear(2 downto 0) <=  "1111100";	--1
	   when "010" =>		--gfedcba
	   	gear(2 downto 0) <=  "0010010";	--2
	   when "011" =>		--gfedcba
	   	gear(2 downto 0) <=  "0011000";  --3
	   when "100" =>		--gfedcba
	   	gear(2 downto 0) <=  "0101100";	--4
	   when "101" =>		--gfedcba
	   	gear(2 downto 0) <=  "0001001";	--5
	   when "110" =>		--gfedcba
	   	gear(2 downto 0) <=  "0000001";	--6
	   when others =>		--gfedcba
	   	gear(2 downto 0) <=  "0000011";	--E, error
	end case;
   end process;
end behavior;

